#include <SoftwareSerial.h>
SoftwareSerial rfidSerial(9, 10);

int lastLenght = 0;//Длина последнего считанного массива
byte respose[12], key[5]  = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF}; //Отдельный массив с ключем и ответом модуля
byte readId[6]            = {0xAB, 0xBA, 0x00, 0x15, 0x00, 0x15};//Команда на сичтывание
//byte writeId[12]          = {0xAB, 0xBA, 0x00, 0x16, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00};//команда на запись
byte writeId[12]            = {0xAB, 0xBA, 0x00, 0x16, 0x05, 0x2E, 0x00, 0xB6, 0xA3, 0x02, 0x2A};//команда на запись

void setup()
{
  Serial.begin(115200);
  rfidSerial.begin(115200);
}

void loop()
{
  int rd = Serial.read();
  if (rd == '1')// ждем ключ и пишим егов массив key
  {
    vaitKey(100);
    keySe();
    printKey(respose);
  }
  if (rd == '2')//пытаемся записать ключ
  {
    //================================================
    int op = 0;
    for (int t = 5; t < 10; ++t)
    {
      writeId[t] = key[op];//формируем команду для отправки модулю
      ++op;
    }
    writeId[10] = xorCheck(writeId);//вставляем последний байт с чек суммой
    //sendComand(writeId, 10);
    //================================================
    //vaitKey(100);
    //printKey(respose, lengt);

    Serial.print("Old key: ");
    //    clearRespose();
    //    vaitKey(100);//Джем ключа
    //    printKey(respose);//выводим ключ
    //
    //    clearRespose();
    sendComand(writeId, 11);//отправляем команду на запись
    readRespose();//читаем ответ
    printKey(respose);//смотрим че пришло

    while (true)
    {
      vaitKey(100);//ждем ключа для кго проверки
      if (keyCheck())//проверяем равны ли ключи
      {
        //vaitKey(100);// если все хошоло то запрашиваем записанный
        printKey(respose);//выводим его
        Serial.print("Write Success");
        return;
      }
      else
      {
        //delay(200);
        clearRespose();
        sendComand(writeId, 11);//Отправляем команду назапись
        readRespose();//Читаем ответ
        printKey(respose);//выводим его
      }
    }
  }
  if (rd == '3')
  {

  }
}

boolean keyCheck()//Проверяем равны ли считанный ключ с тем что пришел в ответ на запрос
{
  int yy = 0;
  for (int o = 5; o <= 9; ++o)
  {
    if (respose[o] != key[o - 5])
    {
      return false;
    }
    ++yy;
  }
  return true;
}

void printKey(byte rp[])//Вывод в консоль
{
  char str[20];
  if (rp[4] == 0x00)// если модуль вернул 0 в значении длинна данных то выводим только команды
  {
    Serial.print(millis() / 1000);
    Serial.print(">> Key: ");
    for (int tr = 2; tr <= 5; ++tr)
    {
      Serial.print(rp[tr], HEX);
      Serial.print(" ");
    }
    Serial.println("");
  }
  else// Выводим весь ответ
  {
    Serial.print(millis() / 1000);
    Serial.print(">> Key: ");
    for (int tr = 5; tr <= 10; ++tr)
    {
      Serial.print(rp[tr], HEX);
      Serial.print(" ");
    }
    Serial.print("Lenght: ");
    Serial.print(rp[4], HEX);
    Serial.println("");
  }
}

void readRespose()//Процедура чтения ответа
{
  /*По протококу модуль в начало ответа шлет заголовок CD DC */
  int yp = 1;
  if (rfidSerial.read() == 0xCD)// Отлавливаем заголовок
  {
    while (rfidSerial.available() > 0)// Читаем пока есть данные
    {
      respose[yp] = rfidSerial.read();
      //Serial.print(respose[yp], HEX);
      //Serial.print(" ");
      ++yp;
      lastLenght = yp;// Счетцик считанных байтов
    }
    Serial.flush();
    //Serial.println("");
  }
}

void keySe()//Выдираем из массива отвера 5 байт самого ключа
{
  int k = 0;
  if (respose[3] == 0x81)
  {
    for (int ui = 5; ui <= 9; ++ui)
    {
      key[k] = respose[ui];
      ++k;
    }
  }
}

void vaitKey(byte vait[], int lenght) //Ждем считываение ключа
{
  do
  {
    clearRespose();       // очистка массива перед чтением
    //rfidSerial.flush();   // На всякий сделал очистку кэша порта
    sendComand(vait, lenght);// Отправляем команду заранее прописанную в массиве AB BA 00 15 00 15
    readRespose();        // Читаем ответ в массив respose
    //delay(vait);          // Пауза чтобы не сильно напрягать модуль
  } while (respose[3] == 0x00 || respose[3] == 0x80);
  /* В случае успешного выполнения команды модуль шлет 81 и в случае провала 80
    00  на проверке про причине первоначальной очистки  массива.*/
}

void vaitKey(int vait)//Ждем считываение ключа
{
  do
  {
    clearRespose();       // очистка массива перед чтением
    //rfidSerial.flush();   // На всякий сделал очистку кэша порта
    sendComand(readId, 6);// Отправляем команду заранее прописанную в массиве AB BA 00 15 00 15
    readRespose();        // Читаем ответ в массив respose
    delay(vait);          // Пауза чтобы не сильно напрягать модуль
  } while (respose[3] == 0x00 || respose[3] == 0x80);
  /* В случае успешного выполнения команды модуль шлет 81 и в случае провала 80
    00  на проверке про причине первоначальной очистки  массива.*/
}

void sendComand(byte comand[], int lenght) //Отправляем команду модулю
{
  rfidSerial.write(comand, lenght);
}

void clearRespose() //Очистка массива в котором хранится ответ
{
  for (int r = 0; r < 12; ++r)
  {
    respose[r] = 0;
  }
}

byte xorCheck(byte rr[]) //Чек сумма отправляемого запроса
{
  int z = 0;
  for (int i = 2; i <= 9; ++i)
  {
    z = z ^ rr[i];
  }
  return z;
}
